
//var statusFile = fb.ComponentPath + "pl_organizer.txt"; 

var statusFile = fb.ProfilePath + "pl_organizer.txt";  
if (utils.IsFile(statusFile) == false) {
	utils.WriteTextFile(statusFile, "");
}
var selected = {
	index: -1,
	pl: 0
}
var list_w;
var showNumb = true;
var units = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
var VK_ADD = 0x6B;
var VK_SUBTRACT = 0x6D;

chars["state1"] = '\uF150';
chars["state2"] = '\uF152';
chars["body"] = '\uF007';
chars["pdf"] = '\uf1c1';
chars["weight"] = '\uf0a0';
chars["number"] = '\uf0cb';
chars["folder_close"] = '\uf07b';
chars["folder_open"] = '\uf07c';
chars["sound"] = '\uf001';



function _pl_organizer(x, y, w, h) {
	this.size = function () {
		this.index = 0;
		this.rows = Math.floor((this.h - _scale(24)) / panel.row_height);
		this.up_btn.x = this.x + this.off + Math.round((list_w - _scale(12)) / 2);
		this.down_btn.x = this.up_btn.x;
		this.up_btn.y = this.y;
		this.down_btn.y = this.y + this.h - _scale(12);
		buttons.update();
	}

	this.draw_row = function (gr, text, colour, x, y, w, h, text_alignment) {
		gr.WriteText(text, panel.fonts.normal, colour, x, y, w, h, text_alignment || DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_CENTER, DWRITE_WORD_WRAPPING_NO_WRAP, DWRITE_TRIMMING_GRANULARITY_CHARACTER);
	}
	this.draw_row_selected = function (gr, text, colour, x, y, w, h, text_alignment) {
		gr.WriteText(text, panel.fonts.bold, colour, x, y, w, h, text_alignment || DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_CENTER, DWRITE_WORD_WRAPPING_NO_WRAP, DWRITE_TRIMMING_GRANULARITY_CHARACTER);
	}
	this.setSel = function (index) {
		selected.index = index;
		selected.pl = this.display[index].pl;
	}
	this.paint = function (gr) {
		if (this.items == 0) {
			return;
		}
		var playing_item_location = plman.GetPlayingItemLocation();
		this.text_width = this.w - this.text_x;
		for (var i = 0; i < Math.min(this.items, this.rows); i++) { //paint the list
			var fold_numbers = 0;
			var indent = this.display[i + this.offset].lvl * 25;
			if (this.display[i + this.offset].pl == 0) { // paint a folder
				var fold = this.display[i + this.offset].name;
				fold_numbers = this.data.filter(function (artr) { //count of playlists in that folder (from this.data because display have excluded them)
					return artr.fold == fold;
				}).length;
				gr.WriteText((this.display[i + this.offset].foldState == '1' ? chars.folder_open : chars.folder_close) + " " + this.display[i + this.offset].name + " [" + fold_numbers + "]", panel.fonts.awesome, panel.colours.text, indent + this.x + this.off, this.y + _scale(12) + (i * panel.row_height), this.text_x - 10, panel.row_height);
				this.draw_row(gr, this.display[i + this.offset].value, panel.colours.text, this.w - 70, this.y + _scale(12) + (i * panel.row_height), panel.calc_text_width(showNumb ? this.display[i + this.offset].value : niceBytes(this.display[i + this.offset].size)) + 20, panel.row_height);
			}
			else {
				// paint a playlist
				if (this.display[i + this.offset].fold != '') { gr.DrawLine(this.x + this.off + (indent / 2), this.y + _scale(12) + (i * panel.row_height) + 8, this.x + this.off + (indent / 2), this.y + _scale(12) + (i * panel.row_height) + 26, 2, RGB(211, 211, 211)); }
				this.draw_row(gr, this.display[i + this.offset].name, panel.colours.text, indent + this.x + this.off, this.y + _scale(12) + (i * panel.row_height), this.text_x - 10, panel.row_height);
				this.draw_row(gr, showNumb ? this.display[i + this.offset].value : niceBytes(this.display[i + this.offset].size), panel.colours.highlight, this.w - 70, this.y + _scale(12) + (i * panel.row_height), panel.calc_text_width(showNumb ? this.display[i + this.offset].value : niceBytes(this.display[i + this.offset].size)) + 20, panel.row_height);
			}
			// paint the active playlist
			if (plman.ActivePlaylist != -1) {
				if (plman.FindPlaylist(this.display[i + this.offset].name) == plman.ActivePlaylist)
					gr.DrawRectangle(this.x + this.off - 4, this.y + _scale(12) + (i * panel.row_height) + 1, this.w - 20, panel.row_height, 1, RGB(255, 255, 0)); // -4 & +1 are there to hide the rectangle when selected
			}
			if (playing_item_location.IsValid) { // file played
				if (this.display[i + this.offset].name == plman.GetPlaylistName(playing_item_location.PlaylistIndex)) 
					gr.WriteText(chars.sound, panel.fonts.awesome, RGB(255, 255, 0), 8, this.y + _scale(12) + (i * panel.row_height)+3, 25, panel.row_height);
			}
		}
		
		if (selected.index > -1) {
			var indent = this.display[selected.index].lvl * 25;
			if (this.display[selected.index].pl == 0) { //paint a selected folder
				var fold = this.display[selected.index].name;
				fold_numbers = this.data.filter(function (artr) { //count of playlists in that folder (from this.data because display have excluded them)
					return artr.fold == fold;
				}).length;
				gr.fillrectangle(this.x + this.off - 5, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), this.w, panel.row_height + 2, RGB(62, 87, 109));
				gr.WriteText((this.display[selected.index].foldState == '1' ? chars.folder_open : chars.folder_close) + " " + this.display[selected.index].name + " [" + fold_numbers + "]", panel.fonts.awesome, RGB(255, 255, 255), indent + this.x + this.off, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), this.text_x - 10, panel.row_height);
				gr.WriteText(this.display[selected.index].value, panel.fonts.awesome, RGB(255, 255, 255), this.w - 70, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), this.text_x - 10, panel.row_height);
			}
			else { // paint a selected pl
				gr.fillrectangle(this.x + this.off - 5, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), this.w, panel.row_height + 2, RGB(62, 87, 109));
				this.draw_row_selected(gr, this.display[selected.index].name, RGB(255, 255, 255), indent + this.x + this.off, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), this.text_x - 10, panel.row_height);
				this.draw_row_selected(gr, showNumb ? this.display[selected.index].value : niceBytes(this.display[selected.index].size), RGB(255, 255, 255), this.w - 70, this.y + _scale(12) + ((selected.index - this.offset) * panel.row_height), panel.calc_text_bold_width(showNumb ? this.display[selected.index].value : niceBytes(this.display[selected.index].size)) + 30, panel.row_height);
			}
		}
		
		if (this.dragDrop) { //if drag & drop
			gr.DrawRectangle(30, this.DragLineY, this.w - 25, this.DragLineH, 2, RGB(255, 0, 0));
		}
		this.up_btn.paint(gr, panel.colours.text);
		this.down_btn.paint(gr, panel.colours.text);
		buttons.paint(gr);
	}

	this.containsXY = function (x, y) {
		return x > this.x + this.off && x < panel.w && y > this.y && y < this.y + this.h;
	}

	this.wheel = function (s) {
		if (this.containsXY(this.mx, this.my)) {
			if (this.items > this.rows) {
				var offset = this.offset - (s * 3);
				if (offset < 0) {
					offset = 0;
				}
				if (offset + this.rows > this.items) {
					offset = this.items - this.rows;
				}
				if (this.offset != offset) {
					this.offset = offset;
					window.Repaint(); 
				}
			}
			return true;
		} else {
			return false;
		}
	}
	this.lbtn_dblck = function (x, y) {
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case !this.in_range:
					break;
				// BELOW TO Double CLICK ON AN ITEM
				case x > this.x + this.off && x < panel.w:
					if (this.display[this.index].pl == 0) {//folder
						if (this.display[this.index].foldState == '1') this.display[this.index].foldState = '0';
						else {
							if (this.autocollapse) {
								for (var i = 0; i < this.data.length; i++) {
									if (this.data[i].foldState == '1' && this.data[i].lvl == '0') this.data[i].foldState = '0';
								}
							}
							this.display[this.index].foldState = '1';
						}
					}
					else {
						plman.ActivePlaylist = plman.FindPlaylist(this.display[this.index].name);
					}
					this.cleanup();
					this.setSel(this.index);
					this.wheel(0);
					window.RepaintRect(this.x, this.y, this.w, this.h);
					break;
			}
			return true;
		}
		return false;
	}


	this.move = function (x, y) {
		if (buttons.move(x, y)) {
			return;
		}
		this.mx = x;
		this.my = y;
		window.SetCursor(IDC_ARROW);
		if (this.containsXY(x, y)) {
			this.index = Math.floor((y - this.y - _scale(12)) / panel.row_height) + this.offset;
			this.in_range = this.index >= this.offset && this.index < this.offset + Math.min(this.rows, this.items);
			switch (true) {
				case this.up_btn.move(x, y):
				case this.down_btn.move(x, y):
					break;
				case !this.in_range:
					break;
				case x > this.x + this.off && x < panel.w:
					window.SetCursor(IDC_HAND);
					if (this.btnDown && Math.abs(this.dragy - y) > 2) {
						if (this.index + 1 - this.offset == this.rows) this.offset = Math.min(this.offset + 1, (this.items - this.rows)); // boundary down
						if (this.index - this.offset == 0) this.offset = Math.max( this.offset - 1 , 0);  // boundary up
						var from = (panel.row_height * (this.index - this.offset + 1)) + 40 - panel.row_height;
						var to = (panel.row_height * (this.index - this.offset + 1)) + 40;
						window.SetCursor(IDC_HELP);
						switch (true) {
							case y >= from && y < from + 7: //|| (y < to && y > to - 10)):
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = from;
								this.DragLineH = 0;
								_tt("Dragging " + this.display[this.draggedIndex].name + " before " + this.display[this.index].name);
								if (this.draggedIndex < this.droppedIndex) this.droppedIndex = this.index - 1; else this.droppedIndex = this.index;
								break;
							case y < to && y > to - 7:
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = to;
								this.DragLineH = 0;
								_tt("Dragging " + this.display[this.draggedIndex].name + " after " + this.display[this.index].name); // ?
								if (this.draggedIndex < this.droppedIndex) this.droppedIndex = this.index ; else this.droppedIndex = this.index+1;
								break;
							case y > from + 7 && y < to - 7 && this.display[this.index].pl == '0':
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = from;
								this.DragLineH = panel.row_height;
								_tt("Dropping " + this.display[this.draggedIndex].name + " in the folder " + this.display[this.index].name); // ?
								this.droppedIndex = this.index;
								break;
							default:
								this.dragDrop = false;
								_tt('');
								break;
						}
						window.repaint();
					}
					else _tt('');
					break;
			}
			return true;
		}
		return false;
	}
	this.lbtn_down = function (x, y) {
		if (this.containsXY(x, y)) {
			this.dragy = y;
			this.btnDown = true;
		}
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case !this.in_range:
					break;
				case x > this.x + this.off && x < panel.w: 
					this.draggedIndex = this.index;
					break;
			}
			return true;
		}
		return false;
	}


	this.lbtn_up = function (x, y) {
		this.btnDown = false;
		if (buttons.lbtn_up(x, y)) {
			return;
		}
		if (this.dragDrop) {
			indexDrop = _.findIndex(this.data, { id: this.display[this.droppedIndex].id });
			id = this.display[this.draggedIndex].id;
			indexDrag = _.findIndex(this.data, { id: id });
			if (this.DragLineH == 0) { // not a folder
				if (this.display[this.draggedIndex].lvl != this.display[this.droppedIndex].lvl) {
					this.data[indexDrag].fold = this.display[this.droppedIndex].fold;
					this.data[indexDrag].lvl = this.display[this.droppedIndex].lvl;
				}
				this.data.move(_.findIndex(this.data, { id: this.display[this.draggedIndex].id }), _.findIndex(this.data, { id: this.display[this.droppedIndex].id }));
			}
			else { //a folder
				this.data[indexDrag].fold = this.data[indexDrop].name;
				this.data[indexDrag].lvl = Number(this.data[indexDrop].lvl) + 1;
			}
			this.dragDrop = false;
			if (this.display[this.droppedIndex].foldState == '0') // if folder is closed then select it otherwise, select the dropped PL
				this.setSel(this.droppedIndex);
			else {
				this.setSel(_.findIndex(this.display, { id: id }));
			}
			this.countFold();
			this.cleanup();
			this.wheel(0);
			window.repaint();
		}
		else {
			if (this.containsXY(x, y)) {
				switch (true) {
					case this.up_btn.lbtn_up(x, y):
					case this.down_btn.lbtn_up(x, y):
					case !this.in_range:
						break;
					case x > this.x + this.off && x < panel.w: // TO CLICK ON AN ITEM
						if (this.display[this.index].pl == 1)
							plman.ActivePlaylist = plman.FindByGUID(this.display[this.index].id) //plman.FindPlaylist(this.display[this.index].name);
						this.setSel(this.index);
						window.RepaintRect(this.x, this.y, panel.w, this.h);
						break;
				}
				return true;
			}
		}
		return false;
	}
	this.rbtn_up = function (x, y) {
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case !this.in_range:
					break;
				case x > this.x + this.off && x < panel.w: 
					if (selected.index > -1) {
						this.l1 = window.CreatePopupMenu();
						panel.m.AppendMenuItem(MF_STRING, 1050, this.autocollapse ? 'Stop Auto-Collapse' : 'Auto-Collapse');
						panel.m.AppendMenuSeparator();
						panel.m.AppendMenuItem(MF_STRING, 1100, 'Move up \t+');
						panel.m.AppendMenuItem(MF_STRING, 1200, 'Move down\t-');
						panel.m.AppendMenuSeparator();
						panel.m.AppendMenuItem(EnableMenuIf(selected.pl == 1 && plman.IsAutoPlaylist(plman.FindByGUID(this.display[selected.index].id))), 1300, 'AutoPlaylist...');
						panel.m.AppendMenuItem(MF_STRING, 1400, 'Rename ' + (selected.pl == 1 ? 'Playlist...' : 'Folder...'));
						panel.m.AppendMenuSeparator();
						panel.m.AppendMenuItem(MF_STRING, 1500, 'Create folder...');
						panel.m.AppendMenuItem(MF_STRING, 1600, 'Create AutoPlaylist');
						panel.m.AppendMenuItem(MF_STRING, 1630, 'Create Playlist');
						panel.m.AppendMenuItem(EnableMenuIf(selected.pl == 1), 1660, 'Convert into a regular playlist');
						panel.m.AppendMenuItem(MF_STRING, 1700, 'Delete ' + (selected.pl == 1 ? 'Playlist...' : 'Folder...') + '\tDel');
						panel.m.AppendMenuSeparator();
						panel.m.AppendMenuItem(EnableMenuIf(this.display[selected.index].lvl > 0 && selected.pl == 1), 1800, 'Put at root');
						this.ctrl ? this.Folder = this.data.filter(function (artr) {
							return artr.pl == '0' && artr.lvl == '0'; 
						}) : this.Folder = this.data.filter(function (artr) {
							return artr.pl == '0' ;
						});
						if (this.Folder.length) {
							this.l1.AppendTo(panel.m, EnableMenuIf(selected.pl == 1), 'Move Playlist into ... \tCtrl for root');
							for (var i = 0; i < this.Folder.length; i++) {
								arr = [];
								for (var j = 0; j < this.Folder.length; j++) {
									if (this.Folder[j].fold == this.Folder[i].name && this.Folder[j].lvl == '1')
										arr.push(this.Folder[j]);
								}
								if (arr.length) {
									this["menu" + j] = window.CreatePopupMenu(); // how to dispose these menus ?
									this["menu" + j].AppendTo(this.l1, MF_STRING, this.Folder[i].name);
									for (var k = 0; k < arr.length; k++) {
										this["menu" + j].AppendMenuItem(MF_STRING, _.findIndex(this.data, { id: arr[k].id}) + 2000, arr[k].name);
									}
								}
								else if (this.Folder[i].lvl == '0') { this.l1.AppendMenuItem(MF_STRING, _.findIndex(this.data, { id: this.Folder[i].id }) +2000, this.Folder[i].name); }
							}
						}
						panel.m.AppendMenuSeparator();
						break;
					}
			}
			return true;
		}
		return false;
	}


	this.rbtn_up_done = function (idx) {
		switch (true) {
			case idx == 1050: //auto collapse
				if (this.autocollapse == false) {
					for (var i = 0; i < this.data.length; i++) {
						if (this.data[i].foldState == '1' && this.data[i].lvl == '0') this.data[i].foldState = '0';
					}
				}
				this.cleanup();
				window.Repaint();
				this.autocollapse = !this.autocollapse;
				break;

			case idx == 1100: //move up
				this.moveUD('up');
				break;
			case idx == 1200: //move down
				this.moveUD('down');
				if (selected.index - this.offset == this.rows) this.offset++;
				break;
			case idx == 1300:
				plman.ShowAutoPlaylistUI(plman.FindByGUID(this.display[selected.index].id));
				break;
			case idx == 1400: // rename a playlist
				try {
					value = utils.InputBox("Give a new name to this playlist", "Rename Playlist", this.display[selected.index].name);
				} catch (e) { return; }
				if (value) {
					if (this.display[selected.index].pl == 1)
						plman.RenamePlaylist(plman.FindByGUID(this.display[selected.index].id), value);
					var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
					for (var i = 0; i < this.data.length; i++) {
						if (this.data[i].fold == this.data[ind].name) this.data[i].fold = value;
					}
					this.data[ind].name = value;
					this.cleanup();
					window.Repaint();
				}
				break;
			case idx == 1500: //create a folder

				try {
					name = utils.InputBox("Input name of the new folder", "Create Folder", "New folder");
				} catch (e) { return; }
				if (name) {
					if (_.findIndex(this.data, { name: name }) == -1) {
						var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
						this.data.splice(ind, 0, {
							"position": selected.index,
							"name": name,
							"value": '0',
							"pl": '0',
							"lvl": Number(this.display[selected.index].lvl),
							"fold": this.display[selected.index].fold,
							"foldState": '0',
							id: ++this.foldCount,
						});

						this.cleanup();
						this.wheel(0);
						window.Repaint();
					}
					else
						utils.MessageBox("You can't create a folder which name : " + name + " already exists", "Warning", MB_OK);
				}
				break;
			case idx == 1600: //create autoplaylist
				try {
					name = utils.InputBox("Input name of the new Autoplaylist", "Create AutoPlaylist");
				} catch (e) { return; }
				if (name) {
					var newind = plman.CreateAutoPlaylist(plman.PlaylistCount, name, "enter your query here" );
					plman.ActivePlaylist = newind;
					plman.ShowAutoPlaylistUI(newind);
				}
				break;
			case idx == 1630: // create playlist
				try {
					name = utils.InputBox("Input name of the new playlist", "Create Playlist");
				} catch (e) { return; }
				if (name) {
					var newind = plman.CreatePlaylist(plman.PlaylistCount, name );
					plman.ActivePlaylist = newind;
				}
				break;

			case idx == 1660: // convert into a regular playlist
				var newind = plman.DuplicatePlaylist(plman.FindByGUID(this.display[selected.index].id), this.display[selected.index].name);
				plman.RemovePlaylist(plman.FindByGUID(this.display[selected.index].id));
				this.data[_.findIndex(this.data, { id: this.display[selected.index].id })].id = plman.GetGUID(newind);
				plman.ActivePlaylist = newind;
				break;
			case idx == 1700: // delete PL or folder
				this.delete();
				this.countFold();
				this.cleanup();
				this.wheel(0);
				window.Repaint();
				break;
			case idx == 1800: // Unfolderize playlist
				this.display[selected.index].lvl = '0';
				this.display[selected.index].fold = '';
				this.countFold();
				this.cleanup();
				this.wheel(0);
				window.Repaint();
				break;
			case idx >= 2000 && idx <= 2000+ this.data.length:  
				var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
				this.data[ind].lvl = Number(this.data[idx - 2000].lvl) + 1;  // increment the level from the folder
				this.data[ind].fold = this.data[idx - 2000].name ;
				selected.index = -1;
				this.countFold();
				this.cleanup();
				this.wheel(0);
				window.Repaint();
				break;
		}
		_dispose(this.l1);
	}

	this.key_up = function (k) {
		switch (k) {
			case VK_CONTROL:
				this.ctrl = false;
				break;
        }
	}

	this.key_down = function (k) {
		switch (k) {
			case VK_UP:
				if (selected.index !== -1 && selected.index !== 0) {
					selected.index--;
					this.setSel(selected.index);
					if (selected.index - this.offset == -1) this.offset--; 
					window.Repaint();
				}
				break;
			case VK_DOWN:
				if (selected.index !== -1 && selected.index !== this.items - 1) {
					selected.index++;
					this.setSel(selected.index);
					if (selected.index - this.offset == this.rows) this.offset++;
					window.Repaint();
				}
				break;
			case VK_DELETE:
				this.delete();
				break;
			case VK_SUBTRACT:
				this.moveUD('up');
				break;
			case VK_ADD:
				this.moveUD('down');
				break;
			case VK_CONTROL:
				this.ctrl = true;
				break;
			default:
				return false;
		}
	}

	this.moveUD = function (direction) {
		if (selected.index !== -1) {
			var from = _.findIndex(this.data, { id: this.display[selected.index].id });
			direction == 'up' ? to = from - 1 : to = from + 1;
			var id = this.data.move(from, to);
			this.cleanup();
			this.setSel(_.findIndex(this.display, { id: id }));
			if (selected.index - this.offset == -1) this.offset--; else if (selected.index - this.offset == this.rows) this.offset++;
			window.Repaint();
		}
    }

	this.delete = function () {
		if (selected.index !== -1) {
			if (selected.pl == 1) { plman.RemovePlaylist(plman.FindByGUID(this.display[selected.index].id)); }
			else { // delete folder
				for (var i = 0; i < this.data.length; i++) {
					if (this.data[i].fold == this.display[selected.index].name) {
						this.data[i].fold = '';
						this.data[i].lvl = '0';
						// playlist contained in the deleted folder falls into the mother folder
					}
				}
			}
			var index = _.findIndex(this.data, { id: this.display[selected.index].id });
			this.data.splice(index, 1); //delete
			this.countFold();
			this.cleanup();
			this.setSel(Math.max(0, Math.min(this.items - 1, selected.index--)));
			this.wheel(0);
			window.Repaint();
		}
	}
	this.countFold = function () {
		for (var i = 0; i < this.data.length; i++) {
			if (this.data[i].pl == '0') { // folder
				var tot = 0;
				for (var j = 0; j < this.data.length; j++) {
					if (this.data[j].fold == this.data[i].name)
						tot = tot + Number(this.data[j].value);
					this.data[i].value = tot;
				}
			}
		}
	}
	this.save_status = function () { // Save latest to file
		strContents = "FORMAT : position;name;#files in PL (-1 if folder);playlist (yes = 1);lvl;folder name (if any) belonged to;folder status (1 = open)" + "\n";
		for (var i = 0; i < this.data.length; i++) {
			strContents = strContents + this.data[i].position + ";" + this.data[i].name + ";" + this.data[i].value + ";" + this.data[i].pl + ";" + this.data[i].lvl + ";" + this.data[i].fold + ";" + this.data[i].foldState + "\n";
		}
		_save(statusFile, strContents);
	}

	this.getFileData = function () { //get file archived status
		var text = utils.ReadUTF8(statusFile);
		var arr = text.split(/\r?\n/)
		dataFile = [];
		for (var i = 1; i < arr.length; i++) {
			var fields = arr[i].split(';');
			dataFile.push({
				"position": fields[0],
				"name": fields[1],
				"value": fields[2],
				"pl": fields[3],
				"lvl": fields[4],
				"fold": fields[5],
				"foldState": fields[6],
			});
		}
		this.BuildData(dataFile);
	}
	this.BuildData = function (dataFile) { // merge file situation to current playlist array (this.data)
		var temparr = [];
		// get positions & lvls
		for (var i = 0; i < this.data.length; i++) {
			var index = _.findIndex(dataFile, { name: this.data[i].name })
			if (index != -1) {
				this.data[i].position = dataFile[index].position;//index;
				this.data[i].pl = dataFile[index].pl;
				this.data[i].lvl = dataFile[index].lvl;
				this.data[i].fold = dataFile[index].fold;
				this.data[i].foldState = dataFile[index].foldState;
			}
			else {
				temparr.push(i);
			}
		}
		// integrate new playlist (not created through this panel with default values
		if (temparr.length != 0) {
			for (var i = 0; i < temparr.length; i++) {
				this.data[temparr[i]].position = this.data.length - temparr.length + i;
				this.data[temparr[i]].pl = '1';
				this.data[temparr[i]].lvl = '0';
			}
		}
		// folders to integrate
		var dataFileFolder = dataFile.filter(function (artr) {
			return artr.pl == '0';
		});
		if (dataFileFolder.length) {
			for (var i = 0; i < dataFileFolder.length; i++) {
				dataFileFolder[i].id = ++this.foldCount;
				this.data.push(dataFileFolder[i]);
			}
		}
		this.data.sort(dynamicSort("position")); // ne trie pas par chiffre mais par texte a comparer  l'autre plus bas (je crois)
	}

	this.getData = function () {  	// get current playlists
		var data = [];
		for (var i = 0; i < plman.PlaylistCount; i++) {
			data.push({
				name: plman.GetPlaylistName(i),
				value: plman.GetPlaylistItemCount(i),
				position: '0',
				pl: '0',
				lvl: '0',
				fold: "",
				foldState: '',
				size: plman.GetPlaylistItems(i).CalcTotalSize(),
				id: plman.GetGUID(i),
			});
		}
		return data;
	}
	this.update = function () {
		this.dragDrop = false;
		this.btnDown = false;
		this.data = this.getData();
		this.text_x = 0;
		this.text_x = list_w + 10;
		if (this.old_offset != 0) this.offset = this.old_offset; else this.offset = 0;
		this.index = 0;
		this.foldCount = 0;
		this.getFileData();
		this.countFold();
		this.cleanup();
		buttons.update();
		window.Repaint();
	}

	this.cleanup = function () {
		var ind = 0;
		this.display = [];
		for (i = 0; i < this.data.length; i++) {
			if (this.data[i].lvl == '0') {  // starting point i will loop the lvl 1 or 2 below 
				this.data[i].position = ind;
				ind++;
				this.display.push(this.data[i]); // if it's lvl 0 then it has to be displayed so i'm pushing it into the display array
				if (this.data[i].pl == '0' && this.data[i].foldState == '1') { // if this is a lvl 0 folder and it's open
					for (j = 0; j < this.data.length; j++) { // loop to check if this folder has sub items or sub folders
						if (this.data[j].fold == this.data[i].name) {
							this.data[j].position = 1000 + (i * 100) + j;
							this.display.push(this.data[j]);
							if (this.data[j].pl == '0' && this.data[j].foldState == '1') { // if there is a lvl 1 sub folder and it's opened
								for (k = 0; k < this.data.length; k++) { // same loop as above for the lvl 2 items
									if (this.data[k].fold == this.data[j].name) {
										this.data[k].position = 2000 + (i * 100) + (j * 10) + k;
										this.display.push(this.data[k]);
									}
								}
							}
                        }
					}
				}
			}
			else {
				if (this.data[_.findIndex(this.data, { name: this.data[i].fold })].foldState == '0') {
					this.data[i].position = 50000 + i;
                }
            }
		}
		this.data.sort(dynamicSort("position"));
		this.items = this.display.length;
		this.save_status();
	}
	this.header_text = function () {
		return "# of playlists : " + this.data.filter(function (artr) {
			return artr.pl == 1;
		}).length;
	}
	this.reset = function () {
		this.old_offset = this.offset; // to keep offset position when updating when focus change
		this.items = 0;
		this.text_x = 0;
		this.data = [];
	}

	var buttons = new _buttons();
	buttons.update = function () {
		this.buttons.numb = new _button(panel.w - 80, 0 - 5, 55, 40, { char: showNumb ? chars.weight : chars.number, colour: RGB(255, 255, 0) }, null, function () { showNumb = !showNumb; buttons.update(); window.Repaint(); }, showNumb ? 'Display Size' : 'Display numbers');
		this.buttons.help = new _button(panel.w - 45, 0 - 5, 55, 40, { char: "?", colour: RGB(211, 211, 211) }, null, function () { showHelp(); }, 'Show help');
	}
	function showHelp() {
		var str = "PlayList Organizer version on JScript panel 3 \n \n";
		str = str + "Known limitations : \n \n";
		str = str + " - Only 2 levels or sub-levels of folder \n"
		str = str + " - Right click only works when a playlist/folder is selected \n"
		str = str + " - Doesnt allow duplicate name for folder \n"
		str = str + " - No multiple selection allowed \n"
		str = str + " - Drag & Drop may lead to crash \n"
		str = str + "\n"
		str = str + "List of functionalities : \n \n";
		str = str + " - Allow duplicate names for folders and playlist \n"
		str = str + " - Drag & drop \n"
		str = str + " - Drag & drop functionalities are also available in the right click menu\n"
		str = str + " - Right click menu is contextual \n"
		str = str + " - Create/Edit/rename/delete existing playlist and autoplaylists\n"
		str = str + " - Switch from number of playlists to Size on disk by cliking on the upper right button\n"
		str = str + " - Auto-Collapse menu allows to have only one folder open (all the other ones will close). ! Works on the first folder level ! \n"
		str = str + " - Playlist in which the current track playing is identified by a yellow note on the left \n"
		str = str + " - Active Playlist is identified by a yellow rectangle \n"
		str = str + " - Single click to open a playlist \n"
		str = str + " - Double click to open or close a folder \n"
		str = str + " - Push + or - buttons to modify the position of the selected folder/playlist \n"
		str = str + " - Mouse wheel, up and down buttons to navigate through the list \n"

		utils.ShowPopupMessage(str, "Help");
    }

	panel.list_objects.push(this);
	this.x = x;
	this.y = y;
	list_w = w;
	this.w = w;
	this.h = h;
	this.mx = 0;
	this.my = 0;
	this.index = 0;
	this.offset = 0;
	this.old_offset = 0;
	this.off = 25;
	this.items = 0;
	this.text_x = 0;
	this.ctrl = false;
	this.autocollapse = false;
	this.up_btn = new _sb(chars.up, this.x + this.off, this.y, _scale(12), _scale(12), _.bind(function () { return this.offset > 0; }, this), _.bind(function () { this.wheel(1); }, this));
	this.down_btn = new _sb(chars.down, this.x + this.off, this.y, _scale(12), _scale(12), _.bind(function () { return this.offset < this.items - this.rows; }, this), _.bind(function () { this.wheel(-1); }, this));
}


//// TOOLS ///////
Array.prototype.move = function (from, to) {
	var i, tmp;
	from = parseInt(from, 10);
	to = parseInt(to, 10);
	if (from !== to && 0 <= from && from <= this.length && 0 <= to && to <= this.length) {
		tmp = this[from];
		if (from < to) {
			for (i = from; i <= to; i++) {
				this[i] = this[i + 1];
			}
		}
		else {
			for (i = from; i >= to; i--) { // >=
				this[i] = this[i - 1];
			}
		}
		this[to] = tmp;
	}
	return this[to < 0 ? 0 : to].id;
}

function dynamicSort(property) { // convert into numbers with the +
	var sortOrder = 1;
	if (property[0] === "-") {
		sortOrder = -1;
		property = property.substr(1);
	}
	return function (a, b) {
		var result = (+a[property] < +b[property]) ? -1 : (+a[property] > +b[property]) ? 1 : 0;
		return result * sortOrder;
	}
}

function niceBytes(x) {
	var l = 0, n = parseInt(x, 10) || 0;
	while (n >= 1024 && ++l) {
		n = n / 1024;
	}
	return (n.toFixed(n < 10 && l > 0 ? 2 : 1) + ' ' + units[l]);
}



//TODOS///////
// mettre le fold id instead of name 
// quand aucune playlist n'existe, pouvoir crr une sans devoir en selectionner une
// try to replace the display/data arrays into a multi dimensional array
